$(function () {
    var error = $('<div class="alert alert-danger" role="alert"></div>');

   $('.magic-csr').click(function () {
       var name = $('#name').val();
       var user = $('.user').text();

       var keys = forge.pki.rsa.generateKeyPair(1024);
       var csr = forge.pki.createCertificationRequest();
       var commonName  = name + '.' + user;

       csr.publicKey = keys.publicKey;
       csr.setSubject([{
           name: 'commonName',
           value: commonName
       }]);
       csr.sign(keys.privateKey);
       var pem = forge.pki.certificationRequestToPem(csr);

       $.post('/panel/certificates/new', {
           csr: pem,
           name: name
       }, function (data) {
           if (data.success) {
               var zip = new JSZip();
               zip.file(commonName + '.key', pem);

               for(var file in data.zip) {
                   zip.file(file, data.zip[file]);
               }
               var content = zip.generate({type:"blob"});
               saveAs(content, commonName + '-vpn.zip');
               location.href = '/panel';
           } else {
               $('h2').after(error.text(data.error));
           }
       });
   });
});
